static char sccsid[]="%W%";
// Creates new tcl shell containing the parsedn2 command.
// the command will take a string containing the dn2 and will
// parse it returning if it contains an error.  It will also
// return a string containing the point to which it was able to
// parse.

/* 
 * tkAppInit.c --
 *
 *	Provides a default version of the Tcl_AppInit procedure for
 *	use in wish and similar Tk-based applications.
 *
 * Copyright (c) 1993 The Regents of the University of California.
 * Copyright (c) 1994 Sun Microsystems, Inc.
 *
 * See the file "license.terms" for information on usage and redistribution
 * of this file, and for a DISCLAIMER OF ALL WARRANTIES.
 */


#include <iostream>
#include <string>
#include <tcl.h>
#include <tk.h>
#include "/home/palmj/src/docman2.5.1.test/tipster.h"

extern "C" {
    extern int Tree_Init(Tcl_Interp *interp);
}

/*
 * The following variable is a special hack that is needed in order for
 * Sun shared libraries to be used for Tcl.
 */

extern "C" {
    extern int matherr();
    int *dummyMathPtr = (int *)matherr;
}

string parsedn2(string&, string&, bool);

extern "C" {
    
    int QueryDN2Command(ClientData client_data,
			Tcl_Interp *interp,
			int objc,
			Tcl_Obj *const objv[])
      {
	  // this will accept a string, convert it into a ByteSequence, and
	  // then call the search engine (talk to Chris about this interface).
	  // The search engine will return with the matching documents and 
	  // a perhaps modified DN2.  This will return the modified DN2 and
	  // the list of matched documentids.
	  
	  
	  //ByteSequence testseq(Tcl_GetStringFromObject(objv[1],NULL));
	  
	  Tcl_Obj *returnobj;
	  
	  // check for correct number of parameters
	  if (objc != 4) {
	      returnobj = Tcl_NewStringObj("Usage: querydn2 <dn2string> returneddn2 docids\n",-1);
	      Tcl_SetObjResult(interp, returnobj);
	      return TCL_ERROR;
	  }
	  
	  string dn2tosend = Tcl_GetStringFromObj(objv[1],NULL);
	  
	  
	  // convert this string into a ByteSequence and send it to the search engine.
	  // The search engine is supposed to return the modified dn2 and a list of
	  // documents.
	  // Convert the modified dn2 (ByteSequence) into a Tcl_String and place it
	  // into objv[2].  Loop through the list of document id and place them into
	  // a list.
	  // ??? Do I fetch the documents at this point and pair them with the ids in 
	  //     the array, or do I write another tcl command for fetching the document
	  //     given the docid???
	  
	  // THIS IS TEST CODE!
	  // remove later

	  // put copy of passed in dn2 into returned dn2
	  Tcl_Obj *tmpdn2, *tmpstringobj, *tmplistobj;
	  tmpdn2 = Tcl_NewStringObj(dn2tosend.c_str(),-1);
	  if (Tcl_ObjSetVar2(interp,objv[2],NULL,tmpdn2,0) == NULL) {
	      Tcl_SetStringObj(returnobj,"ERROR: cannot return string in second parameter\n",-1);
	      Tcl_SetObjResult(interp,returnobj);
	      return TCL_ERROR;
	  }

	  tmplistobj = Tcl_NewListObj(0,NULL);
	  
	  tmpstringobj = Tcl_NewStringObj("a1",-1);
	  Tcl_ListObjAppendElement(interp,tmplistobj,tmpstringobj);

	  tmpstringobj = Tcl_NewStringObj("b2",-1);
	  Tcl_ListObjAppendElement(interp,tmplistobj,tmpstringobj);

	  tmpstringobj = Tcl_NewStringObj("c3",-1);
	  Tcl_ListObjAppendElement(interp,tmplistobj,tmpstringobj);

	  Tcl_ObjSetVar2(interp,objv[3],NULL,tmplistobj,0);
	  
	  // End of TEST CODE
	  
	  returnobj = Tcl_NewIntObj(1);
	  Tcl_SetObjResult(interp,returnobj);
	  return TCL_OK;
      }
    
    int GetDocument(ClientData client_data,
		    Tcl_Interp *interp,
		    int objc,
		    Tcl_Obj *const objv[])
      {
	  Tcl_Obj *returnobj;

	  if (objc != 2) {
	      returnobj = Tcl_NewStringObj("Usage: getdocument id\n",-1);
	      Tcl_SetObjResult(interp,returnobj);
	      return TCL_ERROR;
	  }
	  
	  string docid = Tcl_GetStringFromObj(objv[1],NULL);
	  if (docid == "a1") {
	      returnobj = Tcl_NewStringObj("This is test document #1\nSo there!\n",-1);
	  } else if (docid == "b2") {
	      returnobj = Tcl_NewStringObj("A mighty document test number two\nWould that it be blue!\n",-1);
	  } else if (docid == "c3") {
	      returnobj = Tcl_NewStringObj("Number 3, Number 3, What a beautiful doc you be.\n",-1);
	  } else {
	      returnobj = Tcl_NewStringObj("No document with that id",-1);
	  }

	  Tcl_SetObjResult(interp,returnobj);
	  return TCL_OK;
      }
    
    int ParseDN2Command(ClientData client_data,
			Tcl_Interp *interp,
			int objc,
			Tcl_Obj *const objv[])
      {
	  // This Tcl command will return the number of errors discovered.
	  // usage: parsedn2 [-sgml|-tcl] arg1 [arg2]
	  //   returns the number of errors in the parsing.
	  //   -sgml - optional; default; returns arg2 in sgml format
	  //   -tcl  - optional; returns arg2 in my tcl format
	  //   arg1  - the string containing the dn2 to parse
	  //   arg2  - optional; if present should be a variable name into
	  //           which the parsed dn2 will be passed. FIGURE OUT HOW
	  
	  Tcl_Obj *returnobj,*optionalobj;
	  bool optionalparamflag, returnsgmlflag=true;
	  int i=1;
	  
	  // loop through the argument objects until we are done with all
	  // of the flags.  There can be any number of -sgml and -tcl flags.
	  // The final result is the value of the last flag.  If a flag of neither
	  // of these types is found, we error out.
	  // The counter i keeps track of the current which object we are looking at.
	  
	  string flag = Tcl_GetStringFromObj(objv[i],NULL);
	  while (flag[0] == '-' && i < objc ) {
	      if (flag == "-sgml") {
		  returnsgmlflag = true;
	      } else if (flag == "-tcl") {
		  returnsgmlflag = false;
	      } else {
		  // ERROR: unknown flag
		  returnobj = Tcl_NewStringObj("ERROR: invalid flag",-1);
		  Tcl_SetObjResult(interp,returnobj);
		  return TCL_ERROR;
	      }
	      flag = Tcl_GetStringFromObj(objv[++i],NULL);
	  }
	  
	  if (i == objc) {
	      // ERROR: all we had were flags
	      returnobj = Tcl_NewStringObj("ERROR: There were only flags!",-1);
	      Tcl_SetObjResult(interp,returnobj);
	      return TCL_ERROR;
	  } else if (i == (objc - 1)) {
	      // only one remaining parameter
	      // assume it is a dn2 string
	      optionalparamflag = false;
	  } else if (i == (objc - 2)) {
	      // two remaining non-flag parameters
	      // first is dn2 string; second is return variable
	      optionalparamflag = true;
	  } else {
	      // ERROR: wrong number of parameters
	      returnobj = Tcl_NewStringObj("ERROR: wrong # of parameters",-1);
	      Tcl_SetObjResult(interp,returnobj);
	      return TCL_ERROR;
	  }
	  
	  // call the parser with a string containing the dn2 to check
	  // There are two parsedn2 routines depending on whether it is a
	  // string or list to be returned.
	  string passeddn2 = Tcl_GetStringFromObj(objv[i],NULL);
	  string returneddn2;
	  string errorstring;
	  errorstring = parsedn2(passeddn2,returneddn2,returnsgmlflag);
	  
	  // going to be used if I have to create a Tcl List
	  //if (returnsgmlflag) {
	  //    string returnedstring;
	  //    numerrors = parsedn2(passeddn2,returnedstring);
	  //} else {
	  //    TclObj *returnedlist;
	  //    returnedlist = Tcl_NewListObj(0,NULL); 
	  //    numerrors = parsedn2(passeddn2,returnedlist);
	  //}
	  
	  returnobj = Tcl_NewStringObj(errorstring.c_str(), errorstring.size());  // creates new object with string value
	  
	  if (optionalparamflag) {
	      //char *tmpstr;
	      //tmpstr = new char[returneddn2.size()];
	      //strcpy(tmpstr,returneddn2.c_str());
	      optionalobj = Tcl_NewStringObj(returneddn2.c_str(), returneddn2.size());
	      // set parameter #2 to returneddn2 string
	      if (Tcl_ObjSetVar2(interp,objv[i+1],NULL,optionalobj,0)==NULL) {
		  Tcl_SetStringObj(returnobj,"ERROR: cannot return string in second parameter!",-1);
		  Tcl_SetObjResult(interp,returnobj);
		  return TCL_ERROR;
	      }
	  }
	  
	  Tcl_SetObjResult(interp,returnobj);
	  return TCL_OK;
      }
    
    int Tcl_AppInit(Tcl_Interp *interp) {
	
	if (Tcl_Init(interp) == TCL_ERROR) {
	    return TCL_ERROR;
	};
	
	if (Tk_Init(interp) == TCL_ERROR) {
	    return TCL_ERROR;
	};
	
	/*
	 * Call the init procedures for included packages.  Each call should
	 * look like this:
	 *
	 * if (Mod_Init(interp) == TCL_ERROR) {
	 *     return TCL_ERROR;
	 * }
	 *
	 * where "Mod" is the name of the module.
	 */
	
	/* initialize the tree command */
	if (Tree_Init(interp) == TCL_ERROR) {
	    return TCL_ERROR;
	}
	
	/* ------------------------------------------------------------*/
	/*
	 * Call Tcl_CreateCommand for application-specific commands, if
	 * they weren't already created by the init procedures called above.
	 */
	
	/* Register the new command */
	Tcl_CreateObjCommand(interp,"parsedn2",ParseDN2Command,
			     (ClientData)NULL, (Tcl_CmdDeleteProc *)NULL);

	Tcl_CreateObjCommand(interp,"getdocument",GetDocument,
			     (ClientData)NULL, (Tcl_CmdDeleteProc *)NULL);
	
	Tcl_CreateObjCommand(interp,"querydn2",QueryDN2Command,
			     (ClientData)NULL, (Tcl_CmdDeleteProc *)NULL);
	
	/*
	 * Specify a user-specific startup file to invoke if the application
	 * is run interactively.  Typically the startup file is "~/.apprc"
	 * where "app" is the name of the application.  If this line is deleted
	 * then no user-specific startup file will be run under any conditions.
	 */
	
	
	return TCL_OK;
    }
}

int main(int argc, char **argv) {
    Tk_Main(argc,argv,Tcl_AppInit);
    return 0;
}
